"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FormControl = exports.FormControlTarget = void 0;
const proxykits_1 = require("./formkits.js/proxykits");
class FormControlTarget {
    constructor(scope = {}, value, validators = [], touched = false) {
        this._formControl = {
            scope,
            value,
            validators,
            touched,
            error: false,
            errorMessage: '',
        };
    }
    get touched() {
        return this._formControl.touched;
    }
    get value() {
        return this._formControl.value;
    }
    get validators() {
        return this._formControl.validators;
    }
    get error() {
        for (const validator of this.validators) {
            if (!validator.validatorfunction.call(this._formControl.scope, this.value)) {
                return true;
            }
        }
        return false;
    }
    get errorMessage() {
        for (const validator of this.validators) {
            if (!validator.validatorfunction.call(this._formControl.scope, this.value)) {
                return validator.errorMessage;
            }
        }
        return '';
    }
}
exports.FormControlTarget = FormControlTarget;
const formControlHandler = Object.assign(Object.assign(Object.assign({ construct(target, arg) {
        const { touched, value, error, errorMessage, validators } = new target(...arg);
        return { touched, value, error, errorMessage, validators };
    },
    get(target, prop) {
        if (prop in target) {
            return target[prop];
        }
        throw new Error(`Invalid property ${prop}`);
    },
    set(_, prop, __) {
        throw new Error(`Cannot set property value of ${prop}`);
    } }, proxykits_1.hasProp), proxykits_1.ownKeyProp), proxykits_1.defineProp);
exports.FormControl = new Proxy(FormControlTarget, formControlHandler);
