"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.defineProp = exports.ownKeyProp = exports.hasProp = void 0;
const PREFIX = '_';
exports.hasProp = {
    has(target, key) {
        if (key[0] === '_') {
            return false;
        }
        return key in target;
    },
};
exports.ownKeyProp = {
    ownKeysProps: (obj) => Reflect.ownKeys(obj).filter((prop) => typeof prop !== 'string' || !prop.startsWith(PREFIX)),
};
exports.defineProp = {
    defineProperty(target, key, descriptor) {
        throw new Error(`Invalid attempt to define property ${key}`);
    },
};
